/*
*  HanXHangul.h
*
*   file ۱ Կ ֽϴ.
*  ۱ ڼ  README ۱ κ ñ ٶϴ.
*
*  Copyright: Oh, SungKyu 
*  Sun Oct 15 22:58:20 KST 1995
*
*/

#ifndef __HANXHANGUL_H
#define __HANXHANGUL_H

#define _P(a) ()

typedef unsigned char Char;

#define HANX_INPUT_STRING_LENGTH 160
#define HANX_INPUT_COMBINING_LENGTH 10

struct automata {
    int hangul_state_;
    Char temp_hangul_[HANX_INPUT_COMBINING_LENGTH];
    int sp_, pc_, f_, m_, l_, stack_[10];
    int keyboard_;

    void *ptr;	/* data pointer */
};

extern struct automata *HanX_automata_new _P((int datasize));
/*
extern void HanX_automata_delete _P((struct automata *a));
extern int HanX_automata_ascii _P((struct automata *a, int c, char *buf));
*/
extern int HanX_automata_hangul _P((struct automata *a, int c, char *buf));

#undef _P(a)

#if HANXSTAUTS
static Atom HANX_INPUT_DATA;
static Atom HANX_INPUT_DATA_TYPE;
static Atom HANX_INPUT_MODE;
static Atom HANX_INPUT_MODE_TYPE;
#else
extern Atom HANX_INPUT_DATA;
extern Atom HANX_INPUT_DATA_TYPE;
extern Atom HANX_INPUT_MODE;
extern Atom HANX_INPUT_MODE_TYPE;
#endif

typedef struct {
    Window window;
    int length;
    int curpos;
    char combining[HANX_INPUT_COMBINING_LENGTH];
    char string[HANX_INPUT_STRING_LENGTH];
} HANX_InputDataType;

typedef unsigned long HANX_InputModeType;

enum {
    HANX_INPUT_MODE_LANG_MASK           = 0x000000ff,
       HANX_INPUT_MODE_LANG_ENGLISH     = 0x00000000,
       HANX_INPUT_MODE_LANG_HANGUL      = 0x00000001,
    HANX_INPUT_MODE_LENGTH_MASK         = 0x00000f00,
        HANX_INPUT_MODE_LENGTH_LETTER   = 0x00000000,
        HANX_INPUT_MODE_LENGTH_LINE     = 0x00000100,
    HANX_INPUT_MODE_KEYBOARD_MASK       = 0x0000f000,
    	HANX_INPUT_MODE_KEYBOARD_2BEOL  = 0x00000000,
    	HANX_INPUT_MODE_KEYBOARD_3BEOL  = 0x00001000,
};

extern int HanXOutput;
extern int HanXInput;

/*
extern HANX_InputDataRecord HanX_InputData;
extern int HanX_InputDataChanged;
extern unsigned long HanX_InputMode;
*/


#endif
