/*
*  HanXDrwStr.h
*
*   file ۱ Կ ֽϴ.
*  ۱ ڼ  README ۱ κ ñ ٶϴ.
*
*  Copyright: Oh, SungKyu 
*  Sun Oct 15 22:58:20 KST 1995
*
*/


#if NeedFunctionPrototypes
#define CONCAT(a,b) a ## b
#define CONCAT3(a,b,c) a##b##c
#else
#define CONCAT(a,b) a/**/b
#define CONCAT3(a,b,c) a/**/b/**/c
#endif

#ifdef DrawString

#define HanDrawString HanDrawImageString
#define HanXDrawStringHanFont HanXDrawImageStringHanFont
#define _OrgXDrawString _OrgXDrawImageString

#else

static unsigned char lc;
static int lx, ly;

#endif

static CONCAT(Han,DrawString)(d, w, gc, x, y, str, len)
    Display *d;
    Window w;
    GC gc;
    int x, y;
    register unsigned char* str;
    register int len;
{
    int i, j;
    int n;
    int width;
    register int hx, hy;
    unsigned char *p;
    unsigned char nextlc;
    int sx;

    int hwidth;
    HanFont *hf;

    if (len <= 0) return;

    /* ڸ ϱ  Ŀ ش.*/
    HanCursorOff(d);

    /* ־ Ʈ  ü Ѵ. */
    hf = HanCheckFont(d, gc->values.font);

    hx = x;
    hy = y + hf->diffdescent;
    hwidth = hf->width;

#if DEBUGDRAWSTRING
#if DrawString
    printf("DrawImageString(): %d %d '%02x': %d %d - %d %d - '%02x' %c%c%c%c\n",
        lx, ly, lc, hx, hy, len, hwidth, str[0], str[0], str[1], str[2], str[3]);
#else
    printf("DrawString(): %d %d '%02x': %d %d - %d %d - '%02x' %c%c%c%c\n",
        lx, ly, lc, hx, hy, len, hwidth, str[0], str[0], str[1], str[2], str[3]);
#endif
#endif

    nextlc = 0;
    if (lc) {
	if (ly == hy && lx == (hx-hwidth) && (*str & 0x80)) {
            char s[2]; s[0] = lc; s[1] = *str;
	    CONCAT3(HanX,DrawString,HanFont)(d, w, gc, lx, hy, s, 2, hf);
            hx += hwidth; 
            str++; len--; 
	    nextlc = lc; lc = 0;
        }
    }

    /* ־ ̿ ؼ... */
    while (len > 0) {
	if (*str & 0x80) {	/* MSB setǾ  */

	    /* ° κ ã´. */
	    for (p = str; len > 1 && (*p & 0x80) && (*(p+1) & 0x80);
			p+=2, len-=2)
		;
	    n = p - str;

	    if (n > 0) { 			/* ã */
                CONCAT3(HanX,DrawString,HanFont)(d, w, gc, hx, hy, str, n, hf);
		width = n * hwidth; 
	    }
	    else if (n == 0) {			/* ã */
                if (len == 1) {
		    if (lc && ly == hy && hx == (lx-hwidth)) {/*  */
			char s[2]; s[0] = *str; s[1] = lc;
			CONCAT3(HanX,DrawString,HanFont)
                             (d, w, gc, hx, hy, s, 2, hf);
			hx += hwidth; lc = 0;
                    }
                    else {	/*  ܵ */
                        if (!lc || lx != hx) {
			    nextlc = *str; lx = hx; ly = hy;
                        }
                        HanCursorOn(d, w, gc, 
                            hx, y+hf->fs->max_bounds.descent - hf->height, 
                            hf->width, hf->height);
			lc = nextlc; lx = hx; ly = hy;
                    }
		    width = hwidth;
                }
		else {
	            CONCAT(_OrgX,DrawString)(d, w, gc, hx, y, str, 1);
	            width = _OrgXTextWidth(hf->fs, str, 1);
		}
		p++; len--;
	    }
	}
	else {			/* MSB setǾ   ׳  */
	    for (p = str; len > 0 && !(*p & 0x80); p++, len--)
		;
            n = p - str;
	    CONCAT(_OrgX,DrawString)(d, w, gc, hx, y, str, n);
	    width = _OrgXTextWidth(hf->fs, str, n);
	}

	hx += width;		/* xġ Ų. */
	str = p;		/* Ʈ ġ ű. */
    }

    if (x <= lx && lx < hx && ly == hy || nextlc)
        lc = nextlc;		/*   */
}

#ifdef DrawString
#undef HanDrawString HanDrawImageString
#undef HanXDrawStringHanFont HanXDrawImageStringHanFont
#undef _OrgXDrawString _OrgXDrawImageString
#endif

#undef CONCAT
#undef CONCAT3
