/* HanX v.2.10.8 patch
   Park Jae-hyon (jhpark@entropy.kaist.ac.kr)
   Dec 25, 96 03:24:58 am +0900

    Űų    kisskiss@soback.kornet.nm.kr
     ּ. 
*/

/*
*  HanXOutput.c
*
*   file ۱ Կ ֽϴ.
*  ۱ ڼ  README ۱ κ ñ ٶϴ.
*
*  Copyright: Oh, SungKyu 
*  Sun Oct 15 22:58:20 KST 1995
*
*/


#define DEBUG 0
#define DEBUGFONT 0
#define DEBUGCURSOR 0
#define DEBUGDRAWSTRING 0
#define DEBUGCHAR 0

#if DEBUG
#define debug(a) puts(a)
#else
#define debug(a)
#endif

/*
#define max(a,b) ((a)>(b)?(a):(b))
#define min(a,b) ((a)<(b)?(a):(b))
*/

#include <stdio.h>
#include <X11/X.h>
#include <X11/Xlib.h>
#include "Xlibint.h"
#include "HanXHangul.h"

static HanCursorOn();

static char *stristr(s1, s2)
char *s1, *s2;
{
    int i;
    char c1, c2;

    if (!*s2) return s1;

    while (*s1) {
        c1 = ('a' < *s1 && *s1 < 'z') ? *s1 - 'a'+'A': *s1;
        c2 = ('a' < *s2 && *s2 < 'z') ? *s2 - 'a'+'A': *s2;
	if (c1 == c2) {
	    for (i = 1; s2[i]; i++) {
		c1 = ('a' < s1[i] && s1[i] < 'z') ? s1[i] - 'a'+'A': s1[i];
		c2 = ('a' < s2[i] && s2[i] < 'z') ? s2[i] - 'a'+'A': s2[i];
		if (c1 != c2) break;
	    }
	    if (!s2[i]) return s1;
	}
        s1++;
    }
    return 0;
}

static stricmp(s1, s2)
char *s1, *s2;
{
    int r;

    while (*s1 && *s2) {
        r = ((*s1)&~0x20) - ((*s2)&~0x20);
        if (r) return r;
        s1++, s2++;
    }
    if (*s1) return *s1;
    else return *s2;
}

static char *get_font_name (dpy, fs)
    Display *dpy;
    XFontStruct *fs;
{
    register XFontProp *fp;
    register int i;
    Atom fontatom = XInternAtom (dpy, "FONT", False);

    for (i = 0, fp = fs->properties; i < fs->n_properties; i++, fp++) {
        if (fp->name == fontatom) {
            return (XGetAtomName (dpy, fp->card32));
        }
    }
    return NULL;
}

static searchname(name, n, str)
char *name;
int n;
char *str;
{
    int i;
    for (i = 0; i < n && *name; name++) {
        if (*name == '-') i++;
    }

    while (*name && *name != '-') {
        *str = *name ; str++; name++;
    }
    *str = 0;
}


/***************************************************************/
/* Լ ϱ  Լ Ϳ װ ҷִ ߰Լ */

Font _OrgXLoadFont();
static Font (*_XLoadFont)() = _OrgXLoadFont;
#if NeedFunctionPrototypes
Font XLoadFont(
    Display*            dpy,
    _Xconst char*       name
)
#else
Font XLoadFont(dpy, name)
    Display *dpy;
    char *name;
#endif
{
    return _XLoadFont(dpy, name);
}


XFontStruct *_OrgXQueryFont();
static XFontStruct *(*_XQueryFont)() = _OrgXQueryFont;
XFontStruct *XQueryFont (dpy, fid)
    register Display *dpy;
    Font fid;

{
    return _XQueryFont(dpy, fid);
}

XFontStruct *_OrgXLoadQueryFont();
static XFontStruct *(*_XLoadQueryFont)() = _OrgXLoadQueryFont;
#if NeedFunctionPrototypes
XFontStruct *XLoadQueryFont(
   register Display *dpy,
   const char *name)
#else
XFontStruct *XLoadQueryFont(dpy, name)
   register Display *dpy;
   char *name;
#endif
{
    return _XLoadQueryFont(dpy, name);
}


int _OrgXTextExtents();
static int (*_XTextExtents)() = _OrgXTextExtents;
#if NeedFunctionPrototypes
XTextExtents (
    XFontStruct *fs,
    const char *string,
    int nchars,
    int *dir,           /* RETURN font information */
    int *font_ascent,   /* RETURN font information */
    int *font_descent,  /* RETURN font information */
    register XCharStruct *overall)      /* RETURN character information */
#else
XTextExtents (fs, string, nchars, dir, font_ascent, font_descent, overall)
    XFontStruct *fs;
    char *string;
    int nchars;
    int *dir, *font_ascent, *font_descent;  /* RETURN font information */
    register XCharStruct *overall;      /* RETURN character information */
#endif
{
    return _XTextExtents (fs, string, nchars, 
        dir, font_ascent, font_descent, overall);
}

int _OrgXQueryTextExtents();
static int (*_XQueryTextExtents)() = _OrgXQueryTextExtents;
#if NeedFunctionPrototypes
XQueryTextExtents (
    register Display *dpy,
    Font fid,
    register const char *string,
    register int nchars,
    int *dir,
    int *font_ascent,
    int *font_descent,
    register XCharStruct *overall)
#else
XQueryTextExtents (dpy, fid, string, nchars, dir, font_ascent, font_descent,
                   overall)
    register Display *dpy;
    Font fid;
    register char *string;
    register int nchars;
    int *dir;
    int *font_ascent, *font_descent;
    register XCharStruct *overall;
#endif
{
    return _XQueryTextExtents (dpy, fid, string, nchars, 
	dir, font_ascent, font_descent, overall);
}


int _OrgXTextWidth();
static int (*_XTextWidth)() = _OrgXTextWidth;
#if NeedFunctionPrototypes
int XTextWidth(
    XFontStruct*        fs,
    _Xconst char*       str,
    int                 len
)
#else
int XTextWidth(fs, str, len)
    XFontStruct *fs;
    unsigned char *str;
    int len;
#endif
{
    return _XTextWidth(fs, str, len);
}

int _OrgXDrawString();
static int (*_XDrawString)() = _OrgXDrawString;
#if NeedFunctionPrototypes
int XDrawString(
    Display *dpy,
    Drawable win,
    GC gc,
    int x, int y,
    _Xconst char *string,
    int length
)
#else
int XDrawString(dpy, win, gc, x, y, string, length)
    Display *dpy;
    Drawable win;
    GC gc;
    int x, y;
    char *string;
    int length;
#endif
{
    return _XDrawString(dpy, win, gc, x, y, string, length);
}


int _OrgXDrawImageString();
static int (*_XDrawImageString)() = _OrgXDrawImageString;
#if NeedFunctionPrototypes
int XDrawImageString(
    Display *dpy,
    Drawable win,
    GC gc,
    int x, int y,
    _Xconst char *string,
    int length
)
#else
int XDrawImageString(dpy, win, gc, x, y, string, length)
    Display *dpy;
    Drawable win;
    GC gc;
    int x, y;
    char *string;
    int length;
#endif
{
    return _XDrawImageString(dpy, win, gc, x, y, string, length);
}

int _OrgHanXCursorSet() {}
static int (*_HanXCursorSet)() = _OrgHanXCursorSet;
HanXCursorSet(dpy, win, fs, gc, x, y, width, height)
Display *dpy;
Window win;
XFontStruct *fs;
GC gc;
int x, y;
unsigned width, height;
{
    _HanXCursorSet(dpy, win, fs, gc, x, y, width, height);
}

int _OrgHanXCursorOff() {}
static int (*_HanXCursorOff)() = _OrgHanXCursorOff;
int HanXCursorOff(dpy)
Display *dpy;
{
    _HanXCursorOff(dpy);
}


int _OrgHanXCursorStringChange() {}
static int (*_HanXCursorStringChange)() = _OrgHanXCursorStringChange;
int HanXCursorStringChange(dpy, str)
Display *dpy;
char *str;
{
    _HanXCursorStringChange(dpy, str);
}

extern _OrgXCopyArea();
static (*_XCopyArea)() = _OrgXCopyArea;
XCopyArea(dpy, src_drawable, dst_drawable, gc,
          src_x, src_y, width, height,
          dst_x, dst_y)
     register Display *dpy;
     Drawable src_drawable, dst_drawable;
     GC gc;
     int src_x, src_y;
     unsigned int width, height;
     int dst_x, dst_y;

{
    return _XCopyArea(dpy, src_drawable, dst_drawable, gc,
          src_x, src_y, width, height,
          dst_x, dst_y);
}


extern _OrgXFillRectangle ();
static (*_XFillRectangle) () = _OrgXFillRectangle;
XFillRectangle (dpy, d, gc, x, y, width, height)
    register Display *dpy;
    Drawable d;
    GC gc;
    int x, y;
    unsigned int width, height;
{
    return _XFillRectangle (dpy, d, gc, x, y, width, height);
}


extern XImage *_OrgXGetImage ();
static XImage *(*_XGetImage) () = _OrgXGetImage;
XImage *XGetImage (dpy, d, x, y, width, height, plane_mask, format)
     register Display *dpy;
     Drawable d;
     int x, y;
     unsigned int width, height;
     unsigned long plane_mask;
     int format;	/* either XYPixmap or ZPixmap */
{
    return _XGetImage (dpy, d, x, y, width, height, plane_mask, format);
}

extern _OrgXPutImage ();
static (*_XPutImage) () = _OrgXPutImage;
XPutImage (dpy, d, gc, image, src_x, src_y, dest_x, dest_y, width, height)
    register Display *dpy;
    Drawable d;
    GC gc;
    XImage *image;
    int src_x, src_y;
    int dest_x, dest_y;
    unsigned int width, height;
{
    return _XPutImage (dpy, d, gc, image, src_x, src_y, dest_x, dest_y,
    width, height);
}


extern _OrgXClearArea ();
static (*_XClearArea) () = _OrgXClearArea;
XClearArea (dpy, w, x, y, width, height, exposures)
    register Display *dpy;
    Window w;
    int x, y;
    unsigned int width, height;
    Bool exposures;
{
    return _XClearArea (dpy, w, x, y, width, height, exposures);
}

extern _OrgXClearWindow ();
static (*_XClearWindow) () = _OrgXClearWindow;
XClearWindow (dpy, w)
    register Display *dpy;
    Window w;
{
    return _XClearWindow (dpy, w);
}

/********************************************/


typedef struct hfont {
    struct hfont *next;
    Display *dpy;

    Font fid;
    char *name;
    XFontStruct *fs;

    char *hname;
    XFontStruct *hfs;

    enum { HANFONT_NONE, HANFONT_INTERNAL, HANFONT_16, HANFONT_JOHAB } kind;
    XCharStruct std_per_char;
    unsigned width;     /* average width of ascii font */
    unsigned height;    /* average height of ascii font */
    int diffdescent;       /* difference btw fs->descent and hfs->descent */
    int bold;           /* bold flag */
    int italic;         /* italic flag */
    unsigned short hmask;

} HanFont;

/********************************************/
/*   */

static HanFont *hfontlist = 0;
int HanXOutput = 1;

static int cursorshow = 0; /* Ŀ ȭ鿡 Ÿ ִ°? */
static int cursoron = 0; /* Ŀ ȭ鿡 Ÿ ΰ? */
static int cursorx = -1; /* Ŀ xġ */
static int cursory = -1; /* Ŀ yġ */
static int cursorwidth = 0; /* Ŀ ⺻ width */
static int cursorheight = 0; /* Ŀ ⺻ height */
static int cursorw = 0; /*  Ŀ width */
static int cursorh = 0; /*  Ŀ height */
static int cursormaxw = 16; /* Ŀ max width */
static int cursormaxh = 16; /* Ŀ max height */
static Window cursorwin = 0; /* Ŀ  */
static Window cursorpxm = 0; /* Ŀ ر׸ */
static unsigned long cursorfore = 1; /* Ŀ foreground  */
static unsigned long cursorback = 0; /* Ŀ background  */
static GC cursorgc; /* Ŀ GC */
static unsigned char cursorstr[10] = ""; /* Ŀ Ʈ */
static XFontStruct *cursorfs = 0; /* Ŀ Ʈ XFontStruct structure */
static HanFont *cursorhf = 0; /* Ŀ Ʈ HanFont structure */
static int cursorstrchange = 0; /* Ŀ Ʈ ٲ°? */
static int cursorstrshow = 0; /* Ŀ Ʈ ٰΰ? */

/********************************************/
/* θ Ǵ Լ */


/*
 *  ũ ϱ
*/

static XCharStruct *HanGetPerChar(hf)
HanFont *hf;
{
    XCharStruct *pc = &hf->std_per_char;
    XFontStruct *fs = hf->fs;
    XFontStruct *hfs = hf->hfs;

    switch (hf->kind) {
    case HANFONT_NONE:
        break;
    case HANFONT_INTERNAL:
        pc->ascent = fs->ascent;
        pc->descent = fs->descent;
        pc->width = hf->width;
        pc->rbearing = pc->width;
        pc->lbearing = 0;
        break;
    default:
        pc->ascent = hf->height - fs->descent;
        pc->descent = fs->descent;
        pc->width = hf->width;
        pc->rbearing = pc->width;
        pc->lbearing = 0;
        break;
    }
    return pc;
}

/*
 * ѱƮ Ʈ ¦
*/

static AssociateHanFont(dpy, hf)
    register Display *dpy;
    HanFont *hf;
{
    char *fontname;
    char *hfontname;
    char **fontnames;
    int count;

    int length;
    char hname[256];
    char start[10], 
        fndry[80], fmly[80], wght[80], slant[80], sWdth[80], adstyl[80], 
        pxlsz[80], ptSz[80], resx[80], resy[80], spc[80], avgWdth[80], 
        rgstry[80], encdng[80];
    int try;
    char *trystr;

    hf->hfs = 0;
    hf->bold = 0;
    hf->hname = 0;
    hf->hmask = 0;
    hf->kind = HANFONT_NONE;

    if (hf->fs->min_byte1 || hf->fs->max_byte1) return;

    fontname = get_font_name(dpy, hf->fs);
    if (!fontname) {
        int i;
        int count;
	char **list;
	char *ptr;

#if DEBUGFONT
        printf("get_font_name(%s): failed!\n", hf->name);
#endif

        list = XListFonts(dpy, hf->name, 1, &count);
        if (count == 0) {
            fontname = Xmalloc(strlen(hf->name)+1);
            strcpy(fontname, hf->name);
        }
        else if (count > 0) {
            fontname = Xmalloc(strlen(list[0])+1);
            strcpy(fontname, list[0]);
        }
	else
	    fontname = 0;

	XFreeFontNames(list);

	if (fontname == 0) return;

	for (ptr = fontname; *ptr; ptr++) {
	    if ((*ptr == '-') && (*(ptr+1) >= 'a') && (*(ptr+1) <= 'z'))
		*(ptr+1) = *(ptr+1) - 'a' + 'A';
	}
    }
#if DEBUGFONT
    printf("fontname = %s\n", fontname);
#endif

    length = strlen(fontname);
    if (length > 9 && stricmp(fontname+length-9, "ISO8859-1") == 0) {
        hf->kind = HANFONT_INTERNAL;
    }
    else if (length > 8 && stricmp(fontname+length-8, "1991-irv") == 0) {
        hf->kind = HANFONT_INTERNAL;
    }
    else if (strchr(fontname, '.')) {
        hf->kind = HANFONT_INTERNAL;
    }
    else if (strchr(fontname, 'x')) {
        hf->kind = HANFONT_INTERNAL;
    }
    else if (stristr(fontname, "Lucida")) {
        hf->kind = HANFONT_INTERNAL;
    }
    else if (stristr(fontname, "Times")) {
        hf->kind = HANFONT_INTERNAL;
    }
    else if (stristr(fontname, "Courier")) {
        hf->kind = HANFONT_INTERNAL;
    }
    else if (stristr(fontname, "Bembo")) {
        hf->kind = HANFONT_INTERNAL;
    }
    else if (stristr(fontname, "Helvetica")) {
        hf->kind = HANFONT_INTERNAL;
    }
    else if (stristr(fontname, "NewCenturySchlbk")) {
        hf->kind = HANFONT_INTERNAL;
    }
    else {
#if DEBUGFONT
        printf("fontname = %s\n", fontname);
        printf("AssociateHanFont(): failed\n");
#endif
        goto end;
    }

    hfontname = getenv("HANX_FONT");
    if (hfontname == NULL) hfontname = "-*-*-*-*-*-*-*-*-*-*-*-*-*-*";

    hf->height = hf->fs->max_bounds.ascent + hf->fs->max_bounds.descent;
    hf->width = _OrgXTextWidth(hf->fs, "0", 1);
    hf->bold = (stristr(fontname, "Bold") != 0);
    if ((stristr(fontname, "Italic") != 0) || (stristr(fontname, "-I-") != 0))
        hf->italic = 1;
    else if ((stristr(fontname, "Oblique") != 0) 
		|| (stristr(fontname, "-O-") != 0))
        hf->italic = 2;
    else
        hf->italic = 0;

    searchname(hfontname, 1, fndry);
    searchname(hfontname, 2, fmly);
    searchname(hfontname, 3, wght);
    searchname(hfontname, 4, slant);
    searchname(hfontname, 5, sWdth);
    searchname(hfontname, 6, adstyl);
    searchname(hfontname, 11, spc);
    strcpy(avgWdth, "*");

/*
    strcpy(fndry, "*");
    strcpy(fmly, "*");
    strcpy(sWdth, "*");
    strcpy(adstyl, "*");
    strcpy(spc, "*");
*/

    if (strcmp(wght, "*") == 0) strcpy(wght, (hf->bold)? "bold": "medium");
    if (strcmp(slant, "*") == 0) strcpy(slant, (hf->italic)? "i": "r");

    searchname(fontname, 7, pxlsz);
    searchname(fontname, 8, ptSz);
    searchname(fontname, 10, resy);
    sprintf(resx, "%d", (int)(75.0*hf->width*10*2/atoi(ptSz)+0.99999));

    trystr = getenv("HANX_FONT_TRY");
    if (trystr == NULL) {
        trystr = "1";
    }

#if DEBUGFONT
    printf("HANX_FONT_TRY = %s\n", trystr);
#endif

    while (*trystr) {
        while (*trystr && *trystr == ' ') ++trystr; if (!*trystr) break;
        try = atoi(trystr);
        while (*trystr && *trystr != ' ') ++trystr; 

	switch (try) {
	case 1: 
                strcpy(start, (fndry[0] == '*') ? "" : "*");
    		searchname(fontname, 7, pxlsz);
		break;
	case 2: 
		strcpy(start, (fndry[0] == '*') ? "" : "*"); 
		strcpy(pxlsz, "*"); 
		break;
	case 3: 
#if 0
		/* when size is not appropriate to scaled font */
		if (try == trylevel && hf->height < 16 || hf->width < 8) break;
#endif

		strcpy(start, "-"); 
    		searchname(fontname, 7, pxlsz);
		break;
	}

	/* check for ksc font */

	strcpy(rgstry, "ksc5601.*");
	strcpy(encdng, "0");

	sprintf(hname, "%s%s-%s-%s-%s-%s-%s-%s-%s-%s-%s-%s-%s-%s-%s",
	    start, fndry, fmly, wght, slant, sWdth, adstyl, 
	    pxlsz, ptSz, resx, resy, spc, avgWdth, rgstry, encdng);

	fontnames = XListFonts(dpy, hname, 255, &count);
#if DEBUGFONT
	printf("AssociateFont: ksc5601 fontname = %s\n", hname);
	{ int i;
	  for (i = 0; i < count; i++) {
		printf("AssociateFont: font[%d] = %s\n", i, fontnames[i]);
	  }
	}
#endif
	if (count > 0) {
	    hf->hfs = _OrgXLoadQueryFont(dpy, hname);
	    if (hf->hfs) {
		hf->kind = HANFONT_16;
		if ((hf->hfs->min_byte1 || hf->hfs->max_byte1)
			    && hf->hfs->max_char_or_byte2 < 128)
			hf->hmask = 0x7f;
		else
			hf->hmask = 0xff;
		hf->hname = (char*) Xmalloc(strlen(hname)+1);
		strcpy(hf->hname, hname);   
		hf->diffdescent = hf->fs->descent - hf->hfs->descent;

		goto end;
	    }
	}
	if (count > 0) XFreeFontNames(fontnames);

	/* check for johabs font */

	strcpy(rgstry, "johabs");
	strcpy(encdng, "1");

	sprintf(hname, "%s%s-%s-%s-%s-%s-%s-%s-%s-%s-%s-%s-%s-%s-%s",
	    start, fndry, fmly, wght, slant, sWdth, adstyl, 
	    pxlsz, ptSz, resx, resy, spc, avgWdth, rgstry, encdng);

	fontnames = XListFonts(dpy, hname, 255, &count);
#if DEBUGFONT
	printf("AssociateFont: johab fontname = %s\n", hname);
	{ int i;
	  for (i = 0; i < count; i++) {
		printf("AssociateFont: font[%d] = %s\n", i, fontnames[i]);
	  }
	}
#endif
	if (count > 0) {
	    hf->hfs = _OrgXLoadQueryFont(dpy, hname);
	    if (hf->hfs) {
		hf->kind = HANFONT_JOHAB;
		hf->hname = (char*) Xmalloc(strlen(hname)+1);
		strcpy(hf->hname, hname);   
		hf->diffdescent = 
		    hf->fs->max_bounds.descent - hf->hfs->max_bounds.descent;
		goto end;
	    }
	}
	if (count > 0) XFreeFontNames(fontnames);
    } 

    /* else internal hangul font is used */
    hf->hfs = 0;
    hf->hname = "HanFont Internal";
    hf->diffdescent = hf->fs->max_bounds.descent;

end:
    if (hf->hfs) {
        hf->width = 
	    (hf->hfs->max_bounds.rbearing - hf->hfs->min_bounds.lbearing)/2;
/*
        hf->height = hf->hfs->max_bounds.ascent + hf->hfs->max_bounds.descent;
*/
    }
    XFree(fontname);

#if DEBUGFONT
    printf("AssociateFont(): fontkind = %d\n", hf->kind);
#endif
}

/*
 * ü ϵǾ ִ Ȯ
 */

#if NeedFunctionPrototypes
static HanFont *HanCheckFont (
    Display *dpy,
    Font fid)
#else
static HanFont *HanCheckFont (dpy, fid)
    Display *dpy;
    Font fid;
#endif
{
    HanFont *hf;

    for (hf = hfontlist; hf; hf = hf->next) {
        if (fid == hf->fid && (dpy == hf->dpy || !dpy)) {
            return hf->kind == HANFONT_NONE? 0 : hf;
        }
    }
    return 0;
}


/* 
 * ü  
*/

#if NeedFunctionPrototypes
static HanFont *HanRegisterFont (
    register Display *dpy,
    const char *name,
    Font fid)
#else
static HanFont *HanRegisterFont (dpy, name, fid)
    register Display *dpy;
    char *name;
    Font fid;
#endif
{
    int len;
    HanFont *hf;
    XFontStruct *fs;

    len = strlen(name);
    fs = _OrgXQueryFont(dpy, fid);

    hf  = (HanFont*)Xmalloc(sizeof(HanFont));
    hf->next = hfontlist;
    hf->dpy = dpy;
    hf->fid = fid;
    hf->fs = fs;
    hf->name = (char *)Xmalloc(len+1);
    bcopy(name, hf->name, len+1);

    AssociateHanFont(dpy, hf);

    hfontlist = hf;

    return hf;
}

static HanReconstructFont(fs)
XFontStruct *fs;
{
    register XCharStruct *std_per_char;
    if (fs) {
        HanFont *hf = HanCheckFont(0, fs->fid);

        if (hf) {
            std_per_char = HanGetPerChar(hf);

            fs->max_bounds.ascent =
                    max(fs->max_bounds.ascent, std_per_char->ascent);
            fs->max_bounds.descent =
                    max(fs->max_bounds.descent, std_per_char->descent);

            if (fs->per_char) {
                int i;

                register XCharStruct *per_char =
                        (XCharStruct*) Xmalloc(256 * sizeof(XCharStruct));
                XCharStruct *old_per_char;

                for (i = 0; i <= 127; i++) {
                    per_char[i] = fs->per_char[i];
                }
                for (i = 128; i <= 255; i++) {
                    per_char[i] = *std_per_char;
                }

                old_per_char = fs->per_char;
                fs->per_char = per_char;

                Xfree(old_per_char);
            }
            fs->max_char_or_byte2 = 255;
        }
    }
}


static HanXDrawImageStringHanFont(dpy, win, gc, x, y, string, length, hf)
Display *dpy;
Window win;
GC gc;
int x, y;
unsigned char *string;
unsigned int length;
HanFont *hf;
{
    unsigned int avgwidth, avgheight;
    int bold, italic;
    XGCValues xgcv;

    avgwidth = hf->width;
    avgheight = hf->height;
    bold = hf->bold;
    italic = hf->italic;

    switch (hf->kind) {
    case HANFONT_INTERNAL:
	XGetGCValues(dpy, gc, 
	    GCLineWidth|GCLineStyle|GCCapStyle|GCJoinStyle, &xgcv);

#if DEBUGDRAWSTRING
    printf("HanXDrawImageStringHanFont:\n");
    printf("    :kind = %d  string = \"%c%c\"... length = %d\n",
	hf->kind, string[0], string[1], length);
#endif DEBUGDRAWSTRING

	HanXDrawImageStringHanFontInternal(dpy, win, gc, x, y, 
	    string, length, avgwidth, avgheight, bold, italic);

	XChangeGC(dpy, gc, 
            GCLineWidth|GCLineStyle|GCCapStyle|GCJoinStyle, &xgcv);
        break;
    case HANFONT_16:
	{
	    XChar2b *buf;
	    int i;

	    buf = (XChar2b*)Xmalloc(sizeof(XChar2b) * length);
	    for (i = 0; i < length; i++) {
		buf[i/2].byte1 = string[i] & hf->hmask; i++;
		buf[i/2].byte2 = string[i] & hf->hmask;
	    }
	    {
		XGCValues xgcv;
		long back, fore;

		XGetGCValues(dpy, gc, GCBackground|GCForeground, &xgcv);
		back = xgcv.background;
		fore = xgcv.foreground;

		xgcv.background = fore;
		xgcv.foreground = back;
		XChangeGC(dpy, gc, GCBackground|GCForeground, &xgcv);

		_OrgXFillRectangle(dpy, win, gc, x, y-hf->height+hf->hfs->descent, 
			    hf->width*length, hf->height);

		xgcv.background = back;
		xgcv.foreground = fore;
		XChangeGC(dpy, gc, GCBackground|GCForeground, &xgcv);
	    }

	    XSetFont(dpy, gc, hf->hfs->fid);
	    XDrawImageString16(dpy, win, gc, x, y, buf, length/2);
	    XSetFont(dpy, gc, hf->fid);

	    Xfree(buf);
	    break;
	}
    case HANFONT_JOHAB:
	{
	    int i, n;
	    XChar2b *buf;
            unsigned char code[3];

	    buf = (XChar2b*)Xmalloc(sizeof(XChar2b) * length*4);

            n = 0;
            for (i = 0; i < length; i+=2) {
		HanX_convert_ks_to_3(string[i], string[i+1], code);
                n += HanX_convert_3_to_display(code[0], code[1], code[2], buf+n);
            }
	    {
		XGCValues xgcv;
		long back, fore;

		XGetGCValues(dpy, gc, GCBackground|GCForeground, &xgcv);
		back = xgcv.background;
		fore = xgcv.foreground;

		xgcv.background = fore;
		xgcv.foreground = back;
		XChangeGC(dpy, gc, GCBackground|GCForeground, &xgcv);

		_OrgXFillRectangle(dpy, win, gc, x, y-hf->height+hf->hfs->descent, 
			    hf->width*length, hf->height);

		xgcv.background = back;
		xgcv.foreground = fore;
		XChangeGC(dpy, gc, GCBackground|GCForeground, &xgcv);
	    }

	    XSetFont(dpy, gc, hf->hfs->fid);
	    XDrawImageString16(dpy, win, gc, x, y, buf, n);
	    XSetFont(dpy, gc, hf->fid);

	    Xfree(buf);
	    break;
	}
    }
}

static HanXDrawStringHanFont(dpy, win, gc, x, y, string, length, hf)
Display *dpy;
Window win;
GC gc;
int x, y;
unsigned char *string;
unsigned int length;
HanFont *hf;
{
    unsigned int avgwidth, avgheight;
    int bold, italic;
    XGCValues xgcv;

    avgwidth = hf->width;
    avgheight = hf->height;
    bold = hf->bold;
    italic = hf->italic;


    switch (hf->kind) {
    case HANFONT_INTERNAL:
#if DEBUGDRAWSTRING
    printf("HanXDrawStringHanFont:\n");
    printf("    :kind = %d  string = \"%c%c\"... length = %d\n",
	hf->kind, string[0], string[1], length);
#endif DEBUGDRAWSTRING

	XGetGCValues(dpy, gc, 
	    GCLineWidth|GCLineStyle|GCCapStyle|GCJoinStyle, &xgcv);

	HanXDrawStringHanFontInternal(dpy, win, gc, x, y, string, length,
	    avgwidth, avgheight, bold, italic);

	XChangeGC(dpy, gc, 
            GCLineWidth|GCLineStyle|GCCapStyle|GCJoinStyle, &xgcv);
        break;
    case HANFONT_16:
	{
	    XChar2b *buf;
	    int i;

	    buf = (XChar2b*)Xmalloc(sizeof(XChar2b) * length);
	    for (i = 0; i < length; i++) {
		buf[i/2].byte1 = string[i] & hf->hmask; i++;
		buf[i/2].byte2 = string[i] & hf->hmask;
	    }
	    XSetFont(dpy, gc, hf->hfs->fid);
	    XDrawString16(dpy, win, gc, x, y, buf, length/2);
	    XSetFont(dpy, gc, hf->fid);

	    Xfree(buf);
	    break;
	}
    case HANFONT_JOHAB:
	{
	    int i, n;
	    XChar2b *buf;
            unsigned char code[3];

	    buf = (XChar2b*)Xmalloc(sizeof(XChar2b) * length*4);
            for (i = n = 0; i < length; i+=2) {
                HanX_convert_ks_to_3(string[i], string[i+1], code);
                n += HanX_convert_3_to_display(code[0], code[1], code[2], buf+n);
	    }

	    XSetFont(dpy, gc, hf->hfs->fid);
	    XDrawString16(dpy, win, gc, x, y, buf, n);
	    XSetFont(dpy, gc, hf->fid);

	    Xfree(buf);
	    break;
	}
    }
}


#include "HanXDrwStr.h"
#define DrawString DrawImageString
#include "HanXDrwStr.h"
#undef DrawString


static ReverseImage(image, width, height, fore, back)
XImage *image;
unsigned width, height;
unsigned long fore, back;
{
    unsigned x, y;
    unsigned long pixel;

    for (x = 0; x < width; x++) {
        for (y = 0; y < height; y++) {
	    pixel = XGetPixel(image, x, y);
            if (pixel == fore)
                        XPutPixel(image, x, y, back);
            else
                        XPutPixel(image, x, y, fore);
        }
    }
}


HanCursorShow(dpy)
Display *dpy;
{
#if DEBUGCURSOR
printf("CursorShow()\n");
#endif
    if (cursorstrshow) {
        cursorw = cursorwidth * strlen(cursorstr);
    }
    else  {
        cursorw = cursorwidth;
    }
    cursorh = cursorheight;

    if (cursorw > cursormaxw || cursorh > cursormaxh) {
        XFreePixmap(dpy, cursorpxm);
        cursormaxw = cursorw;
        cursormaxh = cursorh;
        cursorpxm = XCreatePixmap(dpy, DefaultRootWindow(dpy),
            cursormaxw, cursormaxh, DefaultDepth(dpy, DefaultScreen(dpy)));
    }
    
    _OrgXCopyArea(dpy, cursorwin, cursorpxm, cursorgc,
        cursorx, cursory, cursorw, cursorh, 0, 0);
#if DEBUGCURSOR
    printf("CursorShow(): x = %d, y = %d, w = %d, h = %d\n",
        cursorx, cursory, cursorw, cursorh);
#endif

    if (cursorstrshow) {
#if 0
        HanXDrawImageStringHanFontInternal(dpy, cursorwin, cursorgc,
            cursorx, cursory+cursorheight, cursorstr, strlen(cursorstr),
            cursorwidth, cursorheight, 0, 0);
        printf("CursorShow(): x = %d, y = %d\n", cursorx, cursory);
#else
        HanXDrawImageStringHanFont(dpy, cursorwin, cursorgc,
            cursorx, cursory+cursorheight
               -cursorhf->fs->max_bounds.descent+cursorhf->diffdescent, 
            cursorstr, strlen(cursorstr),
	    cursorhf);
#endif
#if DEBUGCURSOR
        printf("CursorShow(): cursorstr = %s, len = %d\n",
		cursorstr, strlen(cursorstr));
#endif
    }
    else {
#if 0
        XGCValues xgcv;
        xgcv.function = GXxor;
        XChangeGC(dpy, cursorgc, GCFunction, &xgcv);
        _OrgXFillRectangle(dpy, cursorwin, cursorgc, cursorx, cursory,
            cursorw, cursorh);
        xgcv.function = GXcopy;
        XChangeGC(dpy, cursorgc, GCFunction, &xgcv);
#else
        XImage *image;
        image = _OrgXGetImage(dpy, cursorpxm, 0, 0, cursorw, cursorh, AllPlanes, ZPixmap);
        ReverseImage(image, cursorw, cursorh, cursorfore, cursorback);
        _OrgXPutImage(dpy, cursorwin, cursorgc, image, 0, 0, cursorx, cursory, cursorw, cursorh);
        XDestroyImage(image);
#endif
    }
    cursorshow = 1;
}



static HanCursorHide(dpy)
{
    if (cursorshow) {
        _OrgXCopyArea(dpy, cursorpxm, cursorwin, cursorgc,
            0, 0, cursorw, cursorh, cursorx, cursory);
        cursorshow = 0;
#if DEBUGCURSOR
    printf("CursorHide(): x = %d, y = %d, w = %d, h = %d\n",
        cursorx, cursory, cursorw, cursorh);
#endif
    }
}

static HanCursorInit(dpy)
Display *dpy;
{
    cursorgc = XCreateGC(dpy, DefaultRootWindow(dpy), 0, 0);
#if 0
#if 0
    XSetForeground(dpy, cursorgc, WhitePixel(dpy, DefaultScreen(dpy)));
    XSetBackground(dpy, cursorgc, BlackPixel(dpy, DefaultScreen(dpy)));
#else
    XSetForeground(dpy, cursorgc, 1);
    XSetBackground(dpy, cursorgc, 0);
#endif
#endif
    XSetFunction(dpy, cursorgc, GXcopy);
    cursorpxm = XCreatePixmap(dpy, DefaultRootWindow(dpy),
        cursormaxw, cursormaxh, DefaultDepth(dpy, DefaultScreen(dpy)));
    {
        unsigned long temp;
        XGCValues xgcv;
        XGetGCValues(dpy, cursorgc, GCBackground|GCForeground, &xgcv);
        cursorback = xgcv.background;
        cursorfore = xgcv.foreground;
    }
}

HanCursorOff(dpy)
Display *dpy;
{
    if (cursorshow) {
        HanCursorHide(dpy);
        cursoron = 0;
    }
#if DEBUGCURSOR
printf("HanCursorOff()\n");
#endif
}

static HanCursorOn(dpy, win, gc, x, y, width, height)
Display *dpy;
Window win;
GC gc;
int x, y;
unsigned width, height;
{
    if (cursorshow) HanCursorOff(dpy);
    
    if (cursorstrshow) return;

    cursorwin = win;
    cursorx = x;
    cursory = y;
    cursorwidth = width;
    cursorheight = height;

    {
        unsigned long temp;
        XGCValues xgcv;
        XGetGCValues(dpy, gc, GCBackground|GCForeground, &xgcv);
        cursorback = xgcv.background;
        cursorfore = xgcv.foreground;
    }
#if 0
#if 0
#if 1
        XCopyGC(dpy, gc, GCForeground|GCBackground, cursorgc);
#else
    {
        unsigned long temp;
        XGCValues xgcv;
        XGetGCValues(dpy, gc, GCBackground|GCForeground, &xgcv);
        temp = xgcv.background;
        xgcv.background = xgcv.foreground;
        xgcv.foreground = temp;
        XChangeGC(dpy, cursorgc, GCBackground|GCForeground, &xgcv);
    }
#endif
#endif
#endif

#if DEBUGCURSOR
printf("CursorOn()\n");
#endif
    HanCursorShow(dpy);
    cursoron = 1;
    
}

static HanCursorSet(dpy, win, fs, gc, x, y, width, height)
Display *dpy;
Window win;
XFontStruct *fs;
GC gc;
int x, y;
unsigned width, height;
{
#if DEBUGCURSOR
    printf("CursorSet(): width = %d, height = %d\n", width, height);
#endif
    if (cursorshow) HanCursorHide(dpy);

    cursorwin = win;
    cursorx = x;
    cursory = y;
    cursorwidth = width;
    cursorheight = height;
    if (cursorfs != fs) {
        cursorhf = HanCheckFont(dpy, fs->fid);
    }
    cursorfs = fs;
#if 1
#if 1
        XCopyGC(dpy, gc, GCForeground|GCBackground, cursorgc);
#else
    {
        unsigned long temp;
        XGCValues xgcv;
        XGetGCValues(dpy, gc, GCBackground|GCForeground, &xgcv);
        temp = xgcv.background;
        xgcv.background = xgcv.foreground;
        xgcv.foreground = temp;
        XChangeGC(dpy, cursorgc, GCBackground|GCForeground, &xgcv);
    }
#endif
#endif
    XSetFont(dpy, cursorgc, fs->fid);
    cursorstrshow = 1;

    if (cursorstr[0]) { HanCursorShow(dpy); XFlush(dpy); }
}

static HanCursorStringChange(dpy, str)
Display *dpy;
char *str;
{
    if (cursorstrshow && cursorstr[0]) {
        cursorstrchange = 1;
    }

    strncpy(cursorstr, str, sizeof(cursorstr)-1);
    cursorstr[sizeof(cursorstr)-1] = '\0';

    if (cursorstrshow && cursorstr[0]) {
        cursorstrchange = 1;
    }

#if DEBUGCURSOR
    printf("HanCursorStringChange(%s): change = %d\n", 
	cursorstr, cursorstrchange);
#endif
}



/*
 *
 * Ŀ  ϴ 
 *
 */

static XImage *HanXGetImage (dpy, d, x, y, width, height, plane_mask, format)
     register Display *dpy;
     Drawable d;
     int x, y;
     unsigned int width, height;
     unsigned long plane_mask;
     int format;	/* either XYPixmap or ZPixmap */
{

#if DEBUGCHAR
    printf("XGetImage(): x = %d, y = %d, width = %d, height = %d\n",
        x, y, width, height);
#endif

    if ((cursorshow || lc) && 
		x < (cursorx+cursorw) && y < (cursory+cursorh) && 
		(x + width) > cursorx && (y + height) > cursory) {
	lc = 0;
        HanXCursorOff(dpy);
    }
    return _OrgXGetImage (dpy, d, x, y, width, height, plane_mask, format);
}

static HanXPutImage(dpy, d, gc, image, src_x, src_y, dest_x, dest_y, width, height)
    register Display *dpy;
    Drawable d;
    GC gc;
    int src_x, src_y;
    int dest_x, dest_y;
    unsigned int width, height;
{

#if DEBUGCHAR
    printf("XPutImage(): src_x = %d, src_y = %d, dest_x = %d, dest_y = %d\n",
        src_x, src_y, dest_x, dest_y);
#endif

    if ((cursorshow || lc) && 
		dest_x < (cursorx+cursorw) && dest_y < (cursory+cursorh) && 
		(dest_x + width) > cursorx && (dest_y + height) > cursory) {
	lc = 0;
        HanXCursorOff(dpy);
    }
    return _OrgXPutImage (dpy, d, gc, image, src_x, src_y, dest_x, dest_y,
    width, height);
}


static HanXCopyArea(dpy, src_drawable, dst_drawable, gc,
          src_x, src_y, width, height,
          dst_x, dst_y)
     register Display *dpy;
     Drawable src_drawable, dst_drawable;
     GC gc;
     int src_x, src_y;
     unsigned int width, height;
     int dst_x, dst_y;

{
/*
    HanClearFragChars(dst_drawable, dst_x, dst_y, width, height);
*/
#if DEBUGCHAR
    printf("HanXCopyArea: src_x = %d, src_y = %d, width = %d, height = %d\n",
        src_x, src_y, width, height);
    printf("HanXCopyArea: dst_x = %d, dst_y = %d\n", dst_x, dst_y);
    printf("HanXCopyArea: cursorshow = %d, lc = %d\n", cursorshow, lc);
    {
int a, b, c;
a = 		src_x < (cursorx+cursorw) && src_y < (cursory+cursorh) && 
		(src_x + width) > cursorx && (src_y + height) > cursory;
b = 		dst_x < (cursorx+cursorw) && dst_y < (cursory+cursorh) && 
		(dst_x + width) > cursorx && (dst_y + height) > cursory;
       c = (cursorshow || lc) && (a || b);
printf("a = %d, b = %d, c = %d\n", a , b , c);
    }
#endif

    if ((cursorshow || lc) && 
		(src_x < (cursorx+cursorw) && src_y < (cursory+cursorh) && 
		(src_x + width) > cursorx && (src_y + height) > cursory
		||
		dst_x < (cursorx+cursorw) && dst_y < (cursory+cursorh) && 
		(dst_x + width) > cursorx && (dst_y + height) > cursory)) {
	lc = 0;
        HanXCursorOff(dpy);
    }
    return _OrgXCopyArea(dpy, src_drawable, dst_drawable, gc,
        src_x, src_y, width, height, dst_x, dst_y);
}

static HanXFillRectangle (dpy, w, gc, x, y, width, height)
    register Display *dpy;
    Window w;
    int x, y;
    unsigned int width, height;
{
#if DEBUGCHAR
    printf("HanXFillRectangle: x = %d, y = %d, width = %d, height = %d\n",
        x, y, width, height);
    printf("HanXFillRectangle: cx = %d, cy = %d, lc = %d\n", cursorx, cursory, lc);
#endif

    if ((cursorshow || lc) && 
		x <= (cursorx) && y <= (cursory) && 
		(x + width) > cursorx && (y + height) > cursory) {
        lc = 0;
        HanXCursorOff(dpy);
    }
    return _OrgXFillRectangle (dpy, w, gc, x, y, width, height);
}

static HanXClearArea (dpy, w, x, y, width, height, exposures)
    register Display *dpy;
    Window w;
    int x, y;
    unsigned int width, height;
    Bool exposures;
{
/*
    HanClearFragChars(w, x, y, width, height);
*/
#if DEBUGCHAR
    printf("HanXClearArea: x = %d, y = %d, width = %d, height = %d\n",
        x, y, width, height);
    printf("HanXClearArea: cx = %d, cy = %d, lc = %d\n", cursorx, cursory, lc);
#endif

    if ((cursorshow || lc) && 
		x <= (cursorx) && y <= (cursory) && 
		(x + width) > cursorx && (y + height) > cursory) {
        lc = 0;
        HanXCursorOff(dpy);
    }
    return _OrgXClearArea (dpy, w, x, y, width, height, exposures);
}

static HanXClearWindow (dpy, w)
    register Display *dpy;
    Window w;
{
#if DEBUGCHAR
    printf("HanXClearWindow\n");
#endif
    HanXCursorOff(dpy);
    return _OrgXClearWindow (dpy, w);
}

/********************************************/
/*   Լ */

/*
 * Ʈ غϱ
*/

#if NeedFunctionPrototypes
static Font HanXLoadFont (
    register Display *dpy,
    const char *name)
#else
static Font HanXLoadFont (dpy, name)
    register Display *dpy;
    char *name;
#endif
{
    Font fid, _OrgXLoadFont();

    fid = _OrgXLoadFont(dpy, name);
    if (fid != BadName) {
        HanRegisterFont(dpy, name, fid);
    }
    return fid;
}

/*
 * XQueryFont
*/

static XFontStruct *HanXQueryFont (dpy, fid)
register Display *dpy;
Font fid;
{
    XFontStruct *fs, *_OrgXQueryFont();
    HanFont *hf;

    hf = HanCheckFont(0, fid);
    fs = _OrgXQueryFont (dpy, fid);
    if (fs && hf && hf->kind != HANFONT_NONE) HanReconstructFont(fs);

    return fs;
}



/* XLoadQueryFont */

#if NeedFunctionPrototypes
static XFontStruct *HanXLoadQueryFont(
   register Display *dpy,
   const char *name)
#else
static XFontStruct *HanXLoadQueryFont(dpy, name)
   register Display *dpy;
   char *name;
#endif
{
    XFontStruct *fs, *_OrgXLoadQueryFont();

    fs = _OrgXLoadQueryFont(dpy, name);
    if (fs) {
        HanFont *hf = HanRegisterFont(dpy, name, fs->fid);
        if (hf->kind != HANFONT_NONE) HanReconstructFont(fs);
    }

    return fs;
}

/*
 * XTextExtents
 */

#if NeedFunctionPrototypes
static HanXTextExtents (
    XFontStruct *fs,
    const char *string,
    int nchars,
    int *dir,           /* RETURN font information */
    int *font_ascent,   /* RETURN font information */
    int *font_descent,  /* RETURN font information */
    register XCharStruct *overall)      /* RETURN character information */
#else
static HanXTextExtents (fs, string, nchars, 
        dir, font_ascent, font_descent, overall)
    XFontStruct *fs;
    char *string;
    int nchars;
    int *dir, *font_ascent, *font_descent;  /* RETURN font information */
    register XCharStruct *overall;      /* RETURN character information */
#endif
{
    HanFont *hf;
    hf = HanCheckFont(0, fs->fid);

    if (!hf)
        return _OrgXTextExtents (fs, string, nchars, dir,
                font_ascent, font_descent, overall);

    {
        register i, n, r;
        register char *str;
        int strwidth;

        if (nchars < 0) nchars = 0;
        str = Xmalloc(nchars);

        for (i = n = 0; i < nchars; i++) {
            if (!(string[i]&0x80)) str[n++] = string[i];
        }

        r = _OrgXTextExtents (fs, str, n, dir,
                font_ascent, font_descent, overall);

        strwidth = (nchars - n) * hf->std_per_char.width;
        overall->lbearing = min(overall->lbearing, hf->std_per_char.lbearing);
        overall->rbearing = overall->rbearing + strwidth;
        overall->width += strwidth;
        overall->ascent = max(overall->ascent, hf->std_per_char.ascent);
        overall->descent = max(overall->descent, hf->std_per_char.descent);
        *font_ascent = max(*font_ascent, hf->std_per_char.ascent);
        *font_descent = max(*font_descent, hf->std_per_char.descent);

        Xfree(str);

        return r;
    }
}

/*
 * XQueryTextExtents
 */

#if NeedFunctionPrototypes
static HanXQueryTextExtents (
    register Display *dpy,
    Font fid,
    register const char *string,
    register int nchars,
    int *dir,
    int *font_ascent,
    int *font_descent,
    register XCharStruct *overall)
#else
static HanXQueryTextExtents (dpy, fid, string, nchars, dir, 
    font_ascent, font_descent, overall)
    register Display *dpy;
    Font fid;
    register char *string;
    register int nchars;
    int *dir;
    int *font_ascent, *font_descent;
    register XCharStruct *overall;
#endif
{
    HanFont *hf;
    hf = HanCheckFont(0, fid);

    if (!hf)
        return _OrgXQueryTextExtents (dpy, fid, string, nchars, dir,
                font_ascent, font_descent, overall);

    {
        register i, n, r;
        char *str;
        int strwidth;

        if (nchars < 0) nchars = 0;
        str = Xmalloc(nchars);

        for (i = n = 0; i < nchars; i++) {
            if (!(string[i]&0x80)) str[n++] = string[i];
        }

        r = _OrgXQueryTextExtents (dpy, fid, str, n, dir,
                font_ascent, font_descent, overall);

        strwidth = (nchars - n) * hf->std_per_char.width;
        overall->lbearing = min(overall->lbearing, hf->std_per_char.lbearing);
        overall->rbearing = overall->rbearing + strwidth;
        overall->width += strwidth;
        overall->ascent = max(overall->ascent, hf->std_per_char.ascent);
        overall->descent = max(overall->descent, hf->std_per_char.descent);
        *font_ascent = max(*font_ascent, hf->std_per_char.ascent);
        *font_descent = max(*font_descent, hf->std_per_char.descent);

        Xfree(str);

        return r;
    }
}



/* 
 * XDrawString 
 */

static int HanXDrawString(display, d, gc, x, y, string, length)
Display *display;
Drawable d;
GC gc;
int x, y;
char *string;
int length;
{
#if DEBUG
    printf("HanXDrawString(): x = %d, y = %d, string[0] = %x\n", 
		x, y, string[0]);
#endif

    if (HanCheckFont(0, gc->values.font)) {
	    return HanDrawString(display, d, gc, x, y, string, length);
    }
    else {
        return _OrgXDrawString(display, d, gc, x, y, string, length);
    }
}


/* 
 * XDrawImageString 
 */

static int HanXDrawImageString(display, d, gc, x, y, string, length)
Display *display;
Drawable d;
GC gc;
int x, y;
char *string;
int length;
{
#if DEBUG
    printf("HanXImageDrawString(): x = %d, y = %d, string[0] = %x\n", 
		x, y, string[0]);
#endif

    if (HanCheckFont(0, gc->values.font)) {
	    return HanDrawImageString(display, d, gc, x, y, string, length);
    }
    else {
        return _OrgXDrawImageString(display, d, gc, x, y, string, length);
    }
}

/*
 * HanXOutputReflect
*/

HanXOutputReflect(dpy)
    register Display *dpy;
{
    if (cursorstrchange) {
        cursorstrchange = 0;
#if DEBUGCURSOR
    printf("HanXOutputReflect: cursorstrshow = %d\n", cursorstrshow);
#endif
        if (cursorstrshow) {
            if (cursorshow) HanCursorHide(dpy);
            if (cursorstr[0]) HanCursorShow(dpy);
            XFlush(dpy);
        }
    }
}

extern HanXDrawStringHangulSub();

static HanXDrawImageStringHangul(dpy, win, gc, x, y, string, length, 
	avgwidth, avgheight, bold, italic)
Display *dpy;
Window win;
GC gc;
int x, y;
unsigned char *string;
unsigned int length;
unsigned int avgwidth, avgheight;
int bold, italic;
{
    XGCValues xgcv;
    long back, fore;

    XGetGCValues(dpy, gc, GCBackground|GCForeground|
	GCLineWidth|GCLineStyle|GCCapStyle|GCJoinStyle, &xgcv);
    back = xgcv.background;
    fore = xgcv.foreground;

    xgcv.background = fore;
    xgcv.foreground = back;
    XChangeGC(dpy, gc, GCBackground|GCForeground, &xgcv);

    HanXFillRectangle(dpy, win, gc, x, y-avgheight, avgwidth*length, avgheight);

    xgcv.background = back;
    xgcv.foreground = fore;
    XChangeGC(dpy, gc, GCBackground|GCForeground, &xgcv);

    HanXDrawStringHangulSub(dpy, win, gc, x, y, string, length, 
	avgwidth, avgheight, bold, italic);

    XChangeGC(dpy, gc, GCLineWidth|GCLineStyle|GCCapStyle|GCJoinStyle, &xgcv);
}

static HanXDrawStringHangul(dpy, win, gc, x, y, string, length, 
	avgwidth, avgheight, bold, italic)
Display *dpy;
Window win;
GC gc;
int x, y;
unsigned char *string;
unsigned int length;
unsigned int avgwidth, avgheight;
int bold, italic;
{
    XGCValues xgcv;
    XGetGCValues(dpy, gc, GCLineWidth|GCLineStyle|GCCapStyle|GCJoinStyle, &xgcv);

    HanXDrawStringHangulSub(dpy, win, gc, x, y, string, length, 
	avgwidth, avgheight, bold, italic);

    XChangeGC(dpy, gc, GCLineWidth|GCLineStyle|GCCapStyle|GCJoinStyle, &xgcv);
}

HanXDrawImageStringHanFontInternal (dpy, win, gc, x, y, string, length, 
	avgwidth, avgheight, bold, italic)
Display *dpy;
Window win;
GC gc;
int x, y;
unsigned char *string;
unsigned int length;
unsigned int avgwidth, avgheight;
int bold, italic;
{
	HanXDrawImageStringHangul(dpy, win, gc, x, y, string, length, 
		avgwidth, avgheight, bold, italic);
}

HanXDrawStringHanFontInternal (dpy, win, gc, x, y, string, length, 
	avgwidth, avgheight, bold, italic)
Display *dpy;
Window win;
GC gc;
int x, y;
unsigned char *string;
unsigned int length;
unsigned int avgwidth, avgheight;
int bold, italic;
{
	HanXDrawStringHangul(dpy, win, gc, x, y, string, length, 
		avgwidth, avgheight, bold, italic);
}

/********************************************/

_HanXOutputInit(dpy)
Display *dpy;
{
    char *disable;
    disable = getenv("HANX_OUTPUT_DISABLE");
   
#if 1
    HanXOutput = (disable == NULL || atoi(disable) == 0);
#else
    HanXOutput = (disable != NULL && atoi(disable) != 1);
#endif
    if (HanXOutput) {
	_XLoadFont = HanXLoadFont;
	_XQueryFont = HanXQueryFont;
	_XLoadQueryFont = HanXLoadQueryFont;
	_XTextExtents = HanXTextExtents;
	_XQueryTextExtents = HanXQueryTextExtents;
        _XDrawString = HanXDrawString;
        _XDrawImageString = HanXDrawImageString;
	_XCopyArea = HanXCopyArea;
	_XClearArea = HanXClearArea;
	_XClearWindow = HanXClearWindow;
        _HanXCursorSet = HanCursorSet;
	_HanXCursorOff = HanCursorOff;
	_HanXCursorStringChange = HanCursorStringChange;
	_XPutImage = HanXPutImage;
	_XGetImage = HanXGetImage;
	_XFillRectangle = HanXFillRectangle;

        HanCursorInit(dpy);
    }
}

int dx_flush_batch()
{
    return 0;
}
